<?php
/**************************************************************************************************
 * Press Class - Shortcode
 **************************************************************************************************/

if ( ! class_exists( 'Themify_Press' ) ) {

	class Themify_Press  extends Themify_Shortcode_Base{
	    
		protected $post_type = 'press';
		protected $tax = 'press-category';
		protected $tag = 'press-tag';
		protected $taxonomies;

		function __construct() {
			parent::__construct();
		}

		/**
		 * Register post type and taxonomy
		 */
		function register() {
			register_post_type( $this->post_type, array(
				'labels' => array(
					'name' => __('Press', 'themify'),
					'singular_name' => __('Press', 'themify'),
					'add_new' => __( 'Add New', 'themify' ),
					'add_new_item' => __( 'Add New Press', 'themify' ),
					'edit_item' => __( 'Edit Press', 'themify' ),
					'new_item' => __( 'New Press', 'themify' ),
					'view_item' => __( 'View Press', 'themify' ),
					'search_items' => __( 'Search Press', 'themify' ),
					'not_found' => __( 'No Press found', 'themify' ),
					'not_found_in_trash' => __( 'No Press found in Trash', 'themify' ),
					'menu_name' => __( 'Press', 'themify' ),
				),
				'supports' => array('title', 'editor', 'thumbnail', 'custom-fields', 'excerpt', 'comments'),
				'hierarchical' => false,
				'public' => true,
				'query_var' => true,
				'can_export' => true,
				'capability_type' => 'post',
				'has_archive' => 'press-archive',
				'rewrite' => array(
					'slug' => themify_get( 'themify_press_slug', $this->post_type, true ),
				),
				'menu_icon' => 'dashicons-megaphone',
			));
			register_taxonomy( $this->tax, array( $this->post_type ), array(
				'labels' => array(
					'name' => __( 'Press Categories', 'themify' ),
					'singular_name' => __( 'Press Categories', 'themify' ),
				),
				'public' => true,
				'show_in_nav_menus' => true,
				'show_ui' => true,
				'show_tagcloud' => true,
				'hierarchical' => true,
				'rewrite' => array(
					'slug' => themify_get( 'themify_press_category_slug',$this->tax,true ),
				),
				'query_var' => true,
			));
			register_taxonomy( $this->tag, array( $this->post_type ), array(
				'labels' => array(
					'name' => __( 'Press Tags', 'themify' ),
					'singular_name' => __( 'Press Tags', 'themify' ),
				),
				'public' => true,
				'show_in_nav_menus' => true,
				'show_ui' => true,
				'show_tagcloud' => true,
				'hierarchical' => false,
				'rewrite' => array(
					'slug' => themify_get( 'themify_press_tag_slug',$this->tag,true ),
				),
				'query_var' => true,
			));
		}

	}
}
/**************************************************************************************************
 * Initialize Type Class
 **************************************************************************************************/
new Themify_Press();
