<?php
/**************************************************************************************************
 * Video Class - Shortcode
 **************************************************************************************************/

if ( ! class_exists( 'Themify_Video' ) ) {

	class Themify_Video  extends Themify_Shortcode_Base{

		protected $post_type = 'video';
		protected $tax = 'video-category';
		protected $tag = 'video-tag';
		protected $taxonomies;
		
		function __construct() {
			parent::__construct();
		}

		/**
		 * Register post type and taxonomy
		 */
		function register() {
			register_post_type( $this->post_type, array(
				'labels' => array(
					'name' => __('Videos', 'themify'),
					'singular_name' => __('Video', 'themify'),
					'add_new' => __( 'Add New', 'themify' ),
					'add_new_item' => __( 'Add New Video', 'themify' ),
					'edit_item' => __( 'Edit Video', 'themify' ),
					'new_item' => __( 'New Video', 'themify' ),
					'view_item' => __( 'View Video', 'themify' ),
					'search_items' => __( 'Search Videos', 'themify' ),
					'not_found' => __( 'No Videos found', 'themify' ),
					'not_found_in_trash' => __( 'No Videos found in Trash', 'themify' ),
					'menu_name' => __( 'Videos', 'themify' ),
				),
				'supports' => array('title', 'editor', 'thumbnail', 'custom-fields', 'excerpt', 'comments'),
				'hierarchical' => false,
				'public' => true,
				'query_var' => true,
				'can_export' => true,
				'capability_type' => 'post',
				'rewrite' => array(
					'slug' => themify_get( 'themify_video_slug',$this->post_type,true ),
				),
				'has_archive' => 'video-archive',
				'menu_icon' => 'dashicons-format-video',
			));
			register_taxonomy( $this->tax, array( $this->post_type ), array(
				'labels' => array(
					'name' => __( 'Video Categories', 'themify' ),
					'singular_name' => __( 'Video Categories', 'themify' ),
				),
				'public' => true,
				'show_in_nav_menus' => true,
				'show_ui' => true,
				'show_tagcloud' => true,
				'hierarchical' => true,
				'rewrite' => array(
					'slug' => themify_get( 'themify_video_category_slug',$this->tax,true ),
				),
				'query_var' => true,
			));
			register_taxonomy( $this->tag, array( $this->post_type ), array(
				'labels' => array(
					'name' => __( 'Video Tags', 'themify' ),
					'singular_name' => __( 'Video Tags', 'themify' ),
				),
				'public' => true,
				'show_in_nav_menus' => true,
				'show_ui' => true,
				'show_tagcloud' => true,
				'hierarchical' => false,
				'rewrite' => array(
					'slug' => themify_get( 'themify_Video_tag_slug' ,$this->tag,true),
				),
				'query_var' => true,
			));
		}


	}
}

/**************************************************************************************************
 * Initialize Type Class
 **************************************************************************************************/
new Themify_Video();
