<?php
/**
 * Template for album post type display.
 * @package themify
 * @since 1.0.0
 */
global $themify;
?>
<?php themify_post_before(); // hook ?>
<article id="post-<?php the_id(); ?>" <?php post_class('post clearfix album-post'); ?>>
	<?php themify_post_start(); // hook ?>

	<?php if ( ! is_singular( 'album' ) || ( isset( $themify->is_shortcode ) && $themify->is_shortcode ) ) : ?>
	    <?php if('yes' !== $themify->unlink_image):?>
		    <a <?php themify_permalink_attr(array('link_class'=>'js-click themify-lightbox tf_abs tf_w tf_h'))?>></a>
	    <?php endif;?>
	    <?php themify_post_media(); ?>
	<?php endif; ?>

	<div class="post-content">

		<?php if ( ! is_singular( 'album' ) || ( isset( $themify->is_shortcode ) && $themify->is_shortcode ) ) : ?>

			<?php themify_post_title( array( 'tag' => 'h2') );?>

			<ul class="record-details">
				<?php if ( $artist = themify_get( 'artist' ) ) : ?>
					<li>
						<h6 class="record-artist"><?php _e( 'Artist', 'themify' ); ?></h6>
						<p class="record-artist"><?php echo $artist; ?></p>
					</li>
				<?php endif; // artist?>
				<?php if ( $released = themify_get( 'released' ) ) : ?>
					<li>
						<h6 class="record-release"><?php _e( 'Released', 'themify' ); ?></h6>
						<p class="record-release"><?php echo $released; ?></p>

					</li>
				<?php endif; // released ?>
				<?php if ( $genre = themify_get( 'genre' ) ) : ?>
					<li>
						<h6 class="record-genre"><?php _e( 'Genre', 'themify' ); ?></h6>
						<p class="record-genre"><?php echo $genre; ?></p>
					</li>
				<?php endif; // genre ?>
			</ul>

		<?php endif; // is single ?>

		<?php themify_post_content();?>

	</div>
	<!-- /.post-content -->
	<?php themify_post_end(); // hook ?>

</article>
<!-- /.post -->
<?php themify_post_after(); // hook ?>
