<?php
/**
 * Template for video post type display.
 * @package themify
 * @since 1.0.0
 */
global $themify;
?>
<?php themify_post_before(); // hook ?>
<article id="post-<?php the_id(); ?>" <?php post_class('post clearfix gallery-post'); ?>>
	<?php themify_post_start(); // hook ?>

	<?php if ( ! is_singular( 'gallery' ) ) : ?>
	    <?php if('yes' !== $themify->unlink_image):?>
		    <a <?php themify_permalink_attr(array('link_class'=>'js-click tf_abs tf_w tf_h'))?>></a>
	    <?php endif;?>
		<?php themify_post_media(); ?>
	<?php endif; ?>

	<div class="post-content">

		<?php if ( ! is_singular( 'gallery' ) ) : ?>

			<?php if ( $themify->hide_meta !== 'yes' || $themify->hide_date !== 'yes' ) : ?>
				<div class="post-meta entry-meta">

					<?php if ( $themify->hide_date !== 'yes' && ( ! is_single() || isset( $themify->is_shortcode ) ) ): ?>

						<time datetime="<?php the_time('o-m-d') ?>" class="post-date entry-date updated">
							<span class="day"><?php the_time( 'j' ); ?></span>
							<span class="month"><?php the_time( 'M' ); ?></span>
							<span class="year"><?php the_time( 'Y' ); ?></span>
						</time>

					<?php endif; //post date ?>

					<?php if($themify->hide_meta !== 'yes'): ?>
						<?php themify_meta_taxonomies();?>
						<?php the_terms( get_the_id(), 'gallery-tag', ' <span class="post-tag">', ', ', '</span>' ); ?>
					<?php endif; //post categories and tags ?>

				</div>
			<?php endif; //post meta ?>

			<?php themify_post_title( array( 'tag' => 'h2' ) ); ?>

		<?php endif; // single view ?>

		<?php themify_post_content();?>

	</div>
	<!-- /.post-content -->
	<?php themify_post_end(); // hook ?>

</article>
<!-- /.post -->
<?php themify_post_after(); // hook ?>