<?php
/**
 * Template for press post type display.
 * @package themify
 * @since 1.0.0
 */
global $themify; ?>
<?php themify_post_before(); // hook ?>
<article id="post-<?php the_id(); ?>" <?php post_class('post clearfix press-post'); ?>>
	<?php themify_post_start(); // hook ?>

	<?php if ( ! is_singular( 'press' ) ) : ?>
		<?php themify_post_media(); ?>
		<div class="post-meta entry-meta clearfix">
			<time class="post-date entry-date updated" datetime="<?php the_time( 'o-m-d' ) ?>">
				<span class="day"><?php the_time( 'j' ); ?></span>
				<span class="month"><?php the_time( 'M' ); ?></span>
				<span class="year"><?php the_time( 'Y' ); ?></span>
			</time>
		</div>
	<?php endif; ?>

	<div class="post-content">

		<?php if ( ! is_singular( 'press' ) ) : ?>

			<?php themify_post_title( array( 'tag' => 'h2' ) ); ?>

			<div class="press-meta-wrapper">
				<?php if ( $themify->hide_meta !== 'yes' ): ?>
					<?php themify_meta_taxonomies();?>

					<?php if ( $themify->hide_meta_tag !== 'yes' ): ?>
						<?php the_terms( get_the_id(), 'post' != get_post_type() ? get_post_type() . '-tag' : 'post_tag', ' <span class="post-tag">', ', ', '</span>' ); ?>
					<?php endif; // meta tag ?>
				<?php endif; //post meta ?>

				<?php get_template_part( 'includes/social-share' ); ?>
			</div>

		<?php endif; // is single ?>

		<?php themify_post_content();?>

	</div>
	<!-- /.post-content -->
	<?php themify_post_end(); // hook ?>

</article>
<!-- /.post -->
<?php themify_post_after(); // hook ?>