<?php
/**
 * Template for generic post display.
 * @package themify
 * @since 1.0.0
 */
global $themify; 
$post_type=get_post_type();
?>
<?php themify_post_before(); // hook ?>
<article id="post-<?php the_id(); ?>" <?php post_class( 'post clearfix' ); ?>>
	<?php themify_post_start(); // hook ?>

	<?php if( 'below' !== $themify->media_position ) themify_post_media(); ?>

	<?php if ( $themify->hide_meta !== 'yes' || $themify->hide_date !== 'yes' ) : ?>
		<div class="post-meta entry-meta clearfix">
			<?php if ( $themify->hide_date !== 'yes' ): ?>
				<time class="post-date entry-date updated" datetime="<?php the_time( 'o-m-d' ) ?>">
					<span class="day"><?php the_time( 'j' ); ?></span>
					<span class="month"><?php the_time( 'M' ); ?></span>
					<span class="year"><?php the_time( 'Y' ); ?></span>
				</time>
			<?php endif; //post date ?>

			<?php if ( $themify->hide_meta !== 'yes' ): ?>
				<?php themify_meta_taxonomies();?>

				<?php if ( $themify->hide_meta_tag !== 'yes' ): ?>
					<?php the_terms( get_the_id(),'post_tag', ' <span class="post-tag">', ', ', '</span>' ); ?>
				<?php endif; // meta tag ?>

				<?php themify_comments_popup_link();?>
			<?php endif; //post meta ?>

			<?php get_template_part( 'includes/social-share' ); ?>
		</div>
		<!-- /post-meta -->
	<?php endif; //post meta ?>

	<div class="post-content">
		<?php themify_post_title(); ?>

		<?php if ( $themify->hide_meta !== 'yes' && $themify->hide_meta_author !== 'yes' ): ?>
			<div class="post-author-wrapper">
				<span class="author-avatar"><?php echo get_avatar( get_the_author_meta( 'user_email' ), $themify->avatar_size_loop, '' ); ?></span>
				<span class="post-author"><?php echo themify_get_author_link() ?></span>
			</div><!-- /.post-author-wrapper -->
		<?php endif; ?>

		<?php if( 'below' === $themify->media_position ) themify_post_media(); ?>

		<?php themify_post_content();?>

	</div>
	<!-- /.post-content -->
	<?php themify_post_end(); // hook ?>

</article>
<!-- /.post -->
<?php themify_post_after(); // hook ?>