<?php
global $themify;

$is_in_lightbox = !empty($_GET['post_in_lightbox']);
?>

<div class="album-container<?php if ($is_in_lightbox === true): ?> tf_scrollbar<?php endif; ?> clearfix">
    <div class="album-cover tf_left">
	<?php themify_post_media(); ?>

	<?php if ($buy_album = themify_get('buy_album')) : ?>
	    <a href="<?php echo esc_url($buy_album); ?>" class="buy-button"><?php _e('Buy Album', 'themify'); ?></a>
	<?php endif; // buy album ?>

	<?php get_template_part('includes/social-share'); ?>

	<?php if ($is_in_lightbox === true) : ?>
	    <div class="album-lightbox-excerpt tf_left tf_w"><?php the_excerpt(); ?></div>
	<?php endif; ?>
    </div>
    <!-- /album cover -->
    <div class="album-info tf_left">
	<ul class="record-details">
	    <?php if ($artist = themify_get('artist')) : ?>
	    <li>
		<h6 class="record-artist"><?php _e('Artist', 'themify'); ?></h6>
		<p class="record-artist" itemprop="byArtist"><?php echo $artist; ?></p>
	    </li>
	    <?php endif; // artist?>
	    <?php if ($released = themify_get('released')) : ?>
	    <li>
		<h6 class="record-release"><?php _e('Released', 'themify'); ?></h6>
		<p class="record-release" itemprop="dateCreated"><?php echo $released; ?></p>
	    </li>
	    <?php endif; // released ?>
	    <?php if ($genre = themify_get('genre')) : ?>
	    <li>
		<h6 class="record-genre"><?php _e('Genre', 'themify'); ?></h6>
		<p class="record-genre" itemprop="genre"><?php echo $genre; ?></p>
	    </li>
	    <?php endif; // genre ?>
	</ul>

    </div>
    <!-- /album-info -->
    <div class="album-playlist tf_left">
	<?php
	if (themify_get('tracks_type', 'sound_tracks') === 'custom_embeds'){
	    echo themify_get('album_embeds');
	}
	else {
	    $playlist = '';
	    $tracks = themify_get('album_tracks');

	    if (!empty($tracks)) {
		foreach ($tracks as $track) {
		    $track_name = '';
		    $track_button = '';
		    $track_attr = array();

		    if (isset($track['name'])) {
			$track_name = sprintf('<a class="track-title" href="#"><span>%s</span></a>', $track['name']);
			$track_attr[] = sprintf('title="%s"', $track['name']);
		    }

		    if (isset($track['file'])) {
			$track_attr[] = sprintf('src="%s"', esc_url(themify_https_esc($track['file'])));
		    }

		    if (!empty($track['button_url'])) {
			$track_button = sprintf('<a href="%s" class="buy-button" target="_blank">%s</a>'
				, esc_url($track['button_url'])
				, !empty($track['button']) ? esc_html($track['button']) : esc_html__('Buy now')
			);
		    }

		    $playlist .= sprintf('<li class="track is-playable">%s[audio %s]%s</li>'
			    , $track_name
			    , do_shortcode(implode(' ', $track_attr))
			    , $track_button);
		}

		printf('<ol class="tracklist">%s</ol>', do_shortcode($playlist));
	    }
	}
	?>
    </div>
    <!-- /album-playlist -->
</div>
