<?php 

$shortcode = themify_get('gallery_shortcode');
$images = themify_get_gallery_shortcode($shortcode);
if ( !empty($images)) : ?>

	<?php
	$columns = themify_get_gallery_shortcode_params($shortcode, 'columns', 3);
	$thumb_size = themify_get_gallery_shortcode_params($shortcode, 'size','thumbnail');
	$use = themify_is_image_script_disabled();
	if($thumb_size!=='full'){
		$size['width']  = get_option( "{$thumb_size}_size_w" );
		$size['height'] = get_option( "{$thumb_size}_size_h" );
	}
	$isNewWp=function_exists('wp_filter_content_tags');
	?>
	<div data-lazy="1" class="gallery gallery-wrapper masonry packery-gallery gallery-columns-<?php echo esc_attr( $columns ); ?> clearfix">
		<?php foreach ( $images as $image ) :


			$caption = Themify_Gallery::get_caption( $image );
			$description = Themify_Gallery::get_description( $image );
			$alt = get_post_meta($image->ID, '_wp_attachment_image_alt', true);
			if(!$alt){
				$alt = $caption?$caption:($description?$description:the_title_attribute('echo=0'));
			}
			$featured = get_post_meta( $image->ID, 'themify_gallery_featured', true );
			$img_size = $thumb_size!=='full'?$size:( $featured?  array('width' => 350,'height' => 350):array('width' => 350,'height' => 200));
			$height = $thumb_size !== 'full' && $featured ? 2 * $size['height'] : $size['height'];
			$thumb = $featured ? 'large' : $thumb_size;
			$img = wp_get_attachment_image_src($image->ID, apply_filters('themify_gallery_post_type_single', $thumb));
			$url = !$featured || $use ? $img[0]:themify_get_image("src={$img[0]}&w={$img_size['width']}&h={$height}&urlonly=true");
			$lightbox_url = $thumb_size!=='large'?wp_get_attachment_image_src($image->ID, 'large'):$img;
			$img = '<img src="'.$url.'" alt="'.esc_attr( $alt ).'" width="'.esc_attr( $img_size['width'] ).'" height="'.esc_attr( $height ).'" class="wp-post-image wp-image-' . $image->ID.'" />';
			$img = $isNewWp===true?wp_filter_content_tags($img):wp_make_content_images_responsive($img);
			?>
			<div class="item gallery-item gallery-icon <?php echo esc_attr( $featured ); ?>">
			    <a href="<?php echo esc_url( $lightbox_url[0] ); ?>" title="<?php esc_attr_e($image->post_title)?>" data-caption="<?php echo esc_attr( $caption ); ?>" data-description="<?php echo esc_attr( $description ); ?>" class="themify_lightbox">
					<div class="gallery-item-wrapper tf_overflow tf_rel tf_h">
						<?php echo $img?>
						<div class="gallery-caption">
							<h2 class="post-title entry-title">
								<?php echo esc_html( $image->post_title ); ?>
							</h2>
						</div>

					</div>
				</a>
			</div>
		<?php endforeach; // images as image ?>
	</div>

<?php endif; // gallery section ?>