/**
 * Lightbox Themibox module
 */
;
(function ($,document,Themify) {
    'use strict';
	const Themibox = {
		lightboxOpen:false,
		init: function() {
			if(!document.getElementById('post-lightbox-wrap')){
				const f=document.createDocumentFragment(),
				wrap=document.createElement('div'),
				overlay=document.createElement('div'),
				clone = document.createElement('div');
				wrap.id='post-lightbox-wrap';
				wrap.className='album-lightbox tf_hide';
				clone.className='clone-wrap';
				overlay.id='overlay';
				overlay.className='tf_w tf_h';
				overlay.addEventListener('click', this.closeLightBox);
				
				f.appendChild(clone);
				f.appendChild(wrap);
				f.appendChild(overlay);
				Themify.body[0].appendChild(f);
			}
			Themify.body.on('click', '.themify-lightbox', this.clickLightBox);
		},
		clickLightBox: function(e) {
			e.preventDefault();
			e.stopPropagation();
			const self=Themibox;
			if(self.lightboxOpen===true){
				return;
			}
			document.addEventListener('keyup', self.keyUp,{passive:true});
			// update status
			self.lightboxOpen = true;

			const $link = $(this),
				url = Themify.UpdateQueryString( 'post_in_lightbox', 1, $link.attr('href') );
			$link.closest('article').find('img').clone().addClass('clone').prependTo('.clone-wrap');
	
			Themify.body.addClass('post-lightbox');
			$('<div id="loader"><div class="themify-loader"><div class="themify-loader_1 themify-loader_blockG"></div><div class="themify-loader_2 themify-loader_blockG"></div><div class="themify-loader_3 themify-loader_blockG"></div></div></div>').appendTo('body');

			$('.clone-wrap').addClass('moved');
			$('.clone').addClass('image-clone');
			$('#post-lightbox-wrap').empty().load(url + ' .album-container',function(){
				if(Themibox.lightboxOpen){
					$('#loader').remove();
					const $self = $(this),
					close = document.createElement('i');
					close.className='close-lightbox tf_close';
					close.addEventListener('click', self.closeLightBox);
					this.insertBefore(close, this.firstChild);
					$self.show();
					$('.image-clone').one('transitionend',function(){
						$self.addClass('flipped');
						Themify.reRun($self);
					}).addClass('flipped');
				}
				Themify.body.triggerHandler('themiboxloaded');
			});
		},

		closeLightBox: function(e) {
			e.stopPropagation();
			e.preventDefault();
			$('.image-clone').remove();
			$('.clone-wrap').removeClass('moved').css({
				'top' : '',
				'left' : ''
			});
			document.removeEventListener('keyup', Themibox.keyUp,{passive:true});
			$('#post-lightbox-wrap').removeClass('flipped');
			// Animation complete.
			$('body').removeClass('post-lightbox');
			$('#post-lightbox-wrap').empty().hide();
			
			Themibox.lightboxOpen = false; // update current status

			Themify.body.triggerHandler('themiboxclosed');

		},
		keyUp: function(e) {
			if (Themibox.lightboxOpen && e.keyCode === 27) {
				$('.close-lightbox').click();
				$('#loader').remove();
			}
		}
	};
	Themify.on('themify_theme_themibox_run',function(){	
		Themibox.init();
	});
})(jQuery,document,Themify);
