
(function ($,Themify) {
	let cssLoad=null,
		ajax=null,
		currentURL=null;
	const ThemifyAjax={
		progress: function (step) {
			let min=0,
				max=0;
			if(step===1){
				min=15;
				max=25;
			}
			else if(step===2){
				min=45;
				max=60;
			}
			else if(step===3){
				min=70;
				max=85;
			}
			else if(step===4){
				min=max=100;
			}
			const percent =Math.floor(Math.random() * (max - min + 1)) + min,
				progress = document.getElementById('themify-progress');
			if(percent===100){
				progress.addEventListener('transitionend',function(){
                                    this.removeAttribute('style');
				},{once:true,passive:true});
			}
			progress.style['width']=percent+'%';
		},
		initClick(){
			const form=document.getElementById('searchform'),
				self=this;
			currentURL=window.location.href;
			$(document).on('click','a',this.click);
			if(form){
				form.addEventListener('submit', function(e){
					e.preventDefault();
					self.search(this);
				});
			}
		},
		init(){
			const self=this;
			setTimeout(function(){
				self.initClick();
				window.addEventListener('popstate', function(e){
					self.popstate();
				}, {passive:false});
			},500);
		},
		render(url,data,isPopState){
			const doc = document.createElement('html'),
				self=this;
			let count=0;
			
			doc.innerHTML=data;

			/* look for Builder generate-style.js script, remove it from doc */
			let generate_style = doc.querySelector( '#tb_builder_js_style-js' ),
				generate_style_extra = doc.querySelector( '#tb_builder_js_style-js-extra' );
			if ( generate_style ) {
				generate_style = document.adoptNode( generate_style );
				generate_style_extra = document.adoptNode( generate_style_extra );
			}

			const newHead=doc.getElementsByTagName('head')[0],
			positionsKeys={},
			positionsVals=[],
			removeAvaibleLinks=[],
			fr=document.createDocumentFragment(),
			origHead=document.getElementsByTagName('head')[0],
			css=newHead.querySelectorAll('link'),
			oldPagewrap=document.getElementById('tf_mainwrap'),
			scripts=doc.querySelectorAll('script'),
			onload=function(e){
				--count;
				if(e && e.type==='error'){
					this.remove();
				}
				if(count<=0){
					self.progress(3);
					const links = origHead.querySelectorAll('link[media="prepare"]'),
						len=links.length;
					let summ=0;
					for(let i=len-1;i>-1;--i){
						links[i].media=links[i].getAttribute('data-media');
					}
					const checkApply=function(){
						const sheets=document.styleSheets;
						for(let i=sheets.length-1;i>-1;--i){
							let href=sheets[i].href;
							if(href){
								for(let j=len-1;j>-1;--j){
									if(href===links[j].getAttribute('href')){
										++summ;
									}
								}
							}
						}
						if(summ>=len){
							const newBody = doc.getElementsByTagName('body')[0],
								oldMeta=origHead.getElementsByTagName('meta'),
								newMeta=newHead.getElementsByTagName('meta'),
							newPagewrap=newBody.querySelector('#tf_mainwrap'),
							newGoogleFonts=newPagewrap.querySelector('#themify-google-fonts-css'),
							oldGoogleFonts=oldPagewrap.querySelector('#themify-google-fonts-css'),
							preloads=newPagewrap.getElementsByTagName('link');
							newPagewrap.className+=' tf_hide tf_abs tf_opacity';
							for(let i=preloads.length-1;i>-1;--i){
								if(preloads[i].hasAttribute('as')){
									preloads[i].remove();
								}
							}
							if(oldGoogleFonts && newGoogleFonts && oldGoogleFonts.href!==newGoogleFonts.href){
								oldGoogleFonts.parentNode.replaceChild(document.adoptNode(newGoogleFonts),oldGoogleFonts);
							}
							oldPagewrap.parentNode.insertBefore(document.adoptNode(newPagewrap),oldPagewrap);
							Themify.trigger('tf_fixed_header_disable').trigger('tb_scroll_highlight_disable');
							$(window).off();
							$(document).off();
							Themify.body.off();
							
							oldPagewrap.addEventListener('transitionend',function(){
								this.remove();
								for(let i=removeAvaibleLinks.length-1;i>-1;--i){
									removeAvaibleLinks[i].parentNode.removeChild(removeAvaibleLinks[i]);
								}
								newPagewrap.classList.remove('tf_abs');
							},{once:true,passive:true});
							
							oldPagewrap.className+=' tf_abs tf_opacity';
							oldPagewrap.style['zIndex']='1';
							newPagewrap.classList.remove('tf_hide');
							for(let i=oldMeta.length-1;i>-1;--i){
								if(oldMeta[i].id!=='themify-framework-css' && oldMeta[i].name!=='viewport' && !oldMeta[i].hasAttribute('charset')){
									oldMeta[i].parentNode.removeChild(oldMeta[i]);
								}
							}
							for(let i=0;i<newMeta.length;++i){
								if(newMeta[i].id!=='themify-framework-css' && newMeta[i].name!=='viewport' && !newMeta[i].hasAttribute('charset')){
									origHead.prepend(newMeta[i]);
								}
							}
							origHead.getElementsByTagName('title')[0].replaceWith(newHead.getElementsByTagName('title')[0]);
							self.progress(4);
							setTimeout(function(){
								const checkStyles=['tf_theme_bg_css','tf_theme_entry_css'];
								for(let i=checkStyles.length-1;i>-1;--i){
									if(newHead.querySelector('#'+checkStyles[i])===null){
										let st=origHead.querySelector('#'+checkStyles[i]);
										if(st){
											st.remove();
										}
									}
								}
								const newStyles=newHead.querySelectorAll('style'),
									oldStyles=origHead.getElementsByTagName('style');
									
								for(let i=0,len=newStyles.length;i<len;++i){
									let id=newStyles[i].id;
									if(id!=='tf_lazy_common' && id!=='tf_lazy_style' && id!=='tf_fonts_style' && id!=='tb_lax_style' && id!=='woocommerce-inline-inline-css'){
										let cssText=newStyles[i].innerText.replace(/ /g, ''),
											found =false;
										for(let j=oldStyles.length-1;j>-1;--j){
											if(cssText===oldStyles[j].innerText.replace(/ /g, '')){
												found=true;
												break;
											}
										}
										if(found===false){
											let st=id?origHead.querySelector('#'+id):null;
											if(st){
												st.innerHTML=newStyles[i].innerHTML;
											}
											else{
												origHead.appendChild(newStyles[i]);
											}
										}
									}
								}
								if (window.scrollY) {
								  window.scroll(0, 0);
								}
								newPagewrap.classList.remove('tf_opacity');
								document.body.className=newBody.className+' page-loaded';
								if (isPopState===true) {
									history.replaceState({path: url}, document.title, url);
								}
								else {
									history.pushState({path: url}, document.title, url);
								}
								const oldJs=document.getElementsByTagName('script');
								for(let i=oldJs.length-1;i>-1;--i){
									oldJs[i].parentNode.removeChild(oldJs[i]);
								}
								document.body.appendChild(fr);
								if(typeof tbLocalScript!=='undefined'){
									tbLocalScript=window['tbLocalScript'];
								}
								themifyScript=window['themifyScript'];
								themify_vars=window['themify_vars'];
								Themify.jsLazy['tf_gallery_init']=false;
								Themify.lazyScroll(Themify.convert(newPagewrap.querySelectorAll('[data-lazy]')).reverse(),true);
								Themify.InitGallery();
								Themify.trigger('themify_theme_init',window['themifyScript']);
								self.initClick();
								Themify.fontAwesome();
								Themify.InitGallery();
								Themify.initWC();
								if (typeof ThemifyBuilderModuleJs !== 'undefined') {
									ThemifyBuilderModuleJs.init();
								}
							},60);
						}
						else{
							setTimeout(checkApply,50);
						}
					};
					checkApply();
				}
			};
			for(let i=css.length-1;i>-1;--i){
				let id=css[i].id;
				if(id==='themify_concate-css' || id==='themify_mobile_concate-css' || id==='themify-media-queries-css'){
					positionsKeys[i]=id;
					positionsVals.push(i);
				}
			}
			positionsVals.sort();
			const pLength=positionsVals.length-1;
			for(let i=0,len=scripts.length;i<len;++i){
				let src=scripts[i].getAttribute('src');
				if((src && src.indexOf('themify.builder.loader')===-1 && (src.indexOf('themify/')!==-1 || src.indexOf('plugins/builder-')!==-1 || src.indexOf('wp-polyfill')!==-1 || src.indexOf('themify-music/js/')!==-1 || src.indexOf('jquery.js')!==-1 || src.indexOf('jquery-migrate.js')!==-1 || src.indexOf('jquery.blockUI.min.js')!==-1))){
					continue;
				}
				let sc=document.createElement('script');
				if(!src){
					sc.innerHTML=scripts[i].innerHTML;
				}
				else{
					let ss = document.createElement('link');
					ss.rel='preload';
					ss.as='script';
					ss.href=src;
					oldPagewrap.appendChild(ss);
				}
				let attr=scripts[i].attributes,
					isVars=scripts[i].id==='tf_vars';
				for(let j=attr.length-1;j>-1;--j){
					if(isVars===true){
						if(attr[j].name==='type'){
							sc.setAttribute(attr[j].name,'text/javascript');
						}
					}
					else{
						sc.setAttribute(attr[j].name,attr[j].value);
					}
				}
				if(src){
					sc.async=false;
				}
				fr.appendChild(sc);
				scripts[i].parentNode.removeChild(scripts[i]);
			}

			/* run generate-style.js file if necessary to create missing Builder stylesheets */
			if ( generate_style ) {
				let sc = document.createElement('script');
				sc.innerHTML = generate_style_extra.innerHTML;
				document.body.appendChild( sc );

				let sc2 = document.createElement('script');
				sc2.addEventListener( 'load', function() {
					Themify.triggerEvent( document, 'tb_regenerate_css' );
				} );
				sc2.async = false;
				sc2.src = generate_style.src;
				document.body.appendChild( sc2 );
			}

			let firstLink=null,
				lastLink=null;
			for(let i=0,len=css.length;i<len;++i){	
				if(css[i].getAttribute('rel')==='stylesheet'){
					let href=css[i].getAttribute('href'),
						id=css[i].id;
					if((!id || id==='themify_concate-css' || id==='themify_mobile_concate-css' || document.getElementById(id)===null) && document.querySelector('link[href="'+href+'"][rel="stylesheet"]')===null){
						let item=document.adoptNode(css[i]);
						item.setAttribute('data-media',(item.getAttribute('media') || 'all'));
						item.setAttribute('media','prepare');
						++count;
						item.addEventListener('load',onload,{passive:true,once:true});
						item.addEventListener('error',onload,{passive:true,once:true});
						if(id==='themify_concate-css' || id==='themify_mobile_concate-css'){
							const concateCss=document.getElementById(id);
							concateCss.parentNode.insertBefore(item,concateCss);
							removeAvaibleLinks.push(concateCss);
						}
						else{
							if(i<positionsVals[0]){
								if(firstLink===null){
									firstLink = document.getElementById(positionsKeys[positionsVals[0]]);
								}
								firstLink.parentNode.insertBefore(item, firstLink);
							}
							else if(i>positionsVals[pLength]){
								if(lastLink===null){
									lastLink = document.getElementById(positionsKeys[positionsVals[pLength]]);
								}
								lastLink.parentNode.insertBefore(item, lastLink.nextSibling);
							}
							else{
								let min=positionsVals[0];
								for(let j=1;j<=pLength;++j){
									if(positionsVals[j]<i){
										min=positionsVals[j];
									}
								}
								let after = document.getElementById(positionsKeys[min]);
								after.parentNode.insertBefore(item, after.nextSibling);
							}
						}
					}
				}
			}
			if(count===0){
				onload();
			}
		},
		click(e){
			if(this.getAttribute('target')!=='_blank' && this.closest('#wpadminbar,.themify_lightbox,.themify-lightbox')===null){
				let url = this.getAttribute('href');
				if(url && url!=='#' && url[0]!=='#' && url !== window.location.href && url.indexOf('post_in_lightbox=')===-1){
					if(url.indexOf(location.hostname)===-1){// if relative to absolute
						const link = document.createElement('a');
						link.href = url;
						url=link.href;
					}
					const parseUrl=new URL(url);
					if(parseUrl.hostname===location.hostname && url.indexOf(themifyScript.site_url)!==-1 && (!parseUrl.hash || parseUrl.pathname!==location.pathname)){
						const ext=parseUrl.pathname.split('.').pop().split('?')[0].split('#')[0].toLowerCase(),
							disable=themifyScript.disable_link;
						if(ext!=='pdf' && ext!=='png'  && ext!=='jpeg' && ext!=='jpg'  && ext!=='gif'  && ext!=='webp' && ext!=='apng' && ext!=='zip' && ext!=='gzip' && ext!=='gz' && ext!=='rar' && ext!=='tar' && ext!=='swf' && ext!=='mp3'&& ext!=='mp4'){
							for(let i=disable.length-1;i>-1;--i){
								if(url.indexOf(disable[i])!==-1){
									return;
								}
							}
							e.preventDefault();
							ThemifyAjax.ajax(Themify.UpdateQueryString('tf_music_ajax',null,url));
						}
					}
				}
				else {
					e.preventDefault();
				}
			}
		},
		search(el){
			const formData=Object.fromEntries(new FormData(el)),
			Url=new URL(el.getAttribute('action'));	
			for (let p in formData){
			  Url.searchParams.append(p, formData[p]);
			}
			if(Url.href && window.location.href!==Url.href){
				this.ajax(Url.href,true);
			}
		},
		popstate(){
			const href=window.location.href,
			url= new URL(href),
			current= new URL(currentURL);
			if(!url.hash || current.pathname!==url.pathname){
				this.ajax(href,true);
			}
		},
		ajax(url,isPopState){
			const self=this;
			if(cssLoad===null){
				Themify.LoadCss(themify_vars.theme_url+'/styles/modules/ajax-loader.css',themify_vars.theme_v,null,null,function(){
					cssLoad=true;
					Themify.trigger('tf_music_ajax_css_loaded');
				});
			}
			if(ajax!==null){
				ajax.abort();
			}
			self.progress(0);
			ajax=$.ajax({
				url: url,
				data:{'tf_music_ajax':1},
				global: false,
				beforeSend: function () {
					$('.close-lightbox').click();
					self.progress(1);
				},
				success:function(data){
					self.progress(2);
					if(cssLoad===true){
						self.render(url,data,isPopState);
					}
					else{
						Themify.on('tf_music_ajax_css_loaded',function(){
							self.render(url,data,isPopState);
						},true);
					}
				}
			});
		}
	};
	
	ThemifyAjax.init();
	

})(jQuery,Themify);
