(function ($,Themify,window,document,themify_vars) {
    'use strict';
    const ThemifyTheme = {
        bodyCl:null,
        headerType:null,
        v:themify_vars.theme_v,
        url:themify_vars.theme_url,
        css_url:null,
        isDone:null,
        js_url:null,
        init(args){
            this.headerType=args.headerType;
            this.bodyCl=Themify.body[0].classList;
            this.css_url=this.url+'/styles/modules/';
            this.js_url=this.url+'/js/modules/';
            this.sideMenu();
            this.headerVideo();
            this.fixedHeader();
            this.mobileMenuDropDown();
            const self=this;
            setTimeout(function(){
                self.initThemibox();
                self.like(args);
            },1000);
            Themify.megaMenu(document.getElementById('main-nav'),true);
            this.onceLoad(args);
        },
        fixedHeader(){
            if(this.bodyCl.contains('fixed-header-enabled') && this.headerType!=='header-bottom' &&  document.getElementById('headerwrap')!==null){
                Themify.FixedHeader();
            }
        },
        headerVideo(){
            const header = document.getElementById('headerwrap');
            if(header){
                    const videos=Themify.selectWithParent('[data-fullwidthvideo]',header);
                    if(videos.length>0){
                        Themify.LoadAsync(this.url + '/js/modules/headerVideo.js',function(){
                                Themify.trigger('themify_theme_header_video_init',[videos]);
                        }, this.v);
                    }
            }
        },
        mobileMenuDropDown(){
            const items = document.getElementsByClassName('toggle-sticky-sidebar');
            for(let i=items.length-1;i>-1;--i){
                items[i].addEventListener('click',function () {
                        var sidebar = $('#sidebar');
                        if ($(this).hasClass('open-toggle-sticky-sidebar')) {
                                $(this).removeClass('open-toggle-sticky-sidebar').addClass('close-toggle-sticky-sidebar');
                                sidebar.addClass('open-mobile-sticky-sidebar');
                        } else {
                                $(this).removeClass('close-toggle-sticky-sidebar').addClass('open-toggle-sticky-sidebar');
                                sidebar.removeClass('open-mobile-sticky-sidebar');
                        }
                },{passive:true});
            }
        },
        initThemibox:function(){
                const self=this;
                let isWorking=false;
                Themify.body.on('click.tf_themibox','.themify-lightbox',function(e){
                        e.stopPropagation();
                        e.preventDefault();
                    if(!isWorking){
                             isWorking=true;
                             const _this=this,
                             checkLoad=function(){
                                if(Themify.cssLazy['theme_album_lightbox']===true && Themify.cssLazy['theme_album_single']===true && Themify.jsLazy['theme_themibox']===true){
                                    Themify.trigger('themify_theme_themibox_run').body.off('click.tf_themibox');
                                    _this.click();
                                }
                             };
                            if(!Themify.cssLazy['theme_album_lightbox']){
                                Themify.LoadCss(self.css_url+'album-lightbox.css',self.v,null,null,function(){
                                        Themify.cssLazy['theme_album_lightbox']=true;
                                        checkLoad();
                                });
                            }
                            if(!Themify.cssLazy['theme_album_single']){
                                Themify.LoadCss(self.css_url+'single/album.css',self.v,null,null,function(){
                                        Themify.cssLazy['theme_album_single']=true;
                                        checkLoad();
                                });
                            }
                            if(!Themify.jsLazy['theme_themibox']){
                                Themify.LoadAsync(self.js_url + 'themibox.js', function () {
                                        Themify.jsLazy['theme_themibox']=true;
                                        checkLoad();
                                },
                                self.v);
                            }
                            checkLoad();
                     }
                });
            },
        sideMenu(){
            Themify.sideMenu(document.getElementById('menu-icon'),{
                close: '#menu-icon-close',
                side:this.headerType==='header-leftpane' || this.headerType==='header-minbar'?'left':'right',
                hasOverlay:!(this.headerType==='header-slide-out' || this.headerType==='header-rightpane')
            });
        },
        clickEvents(){
            const back_top = document.getElementsByClassName('floating-back-top')[0],
                tooglePlayer=document.getElementsByClassName('button-switch-player')[0];
                if (back_top) {
					const events =['scroll'],
						scroll=function(){
								back_top.classList.toggle ('tf_opacity',(this.scrollY < 10));

						};
						if(Themify.isTouch){
								events.push('touchstart');
								events.push('touchmove');
						}
						for(let i=events.length-1;i>-1;--i){
								window.addEventListener(events[i],scroll,{passive:true});
						}
						back_top.addEventListener('click',function (e) {
								e.preventDefault();
								e.stopPropagation();
								Themify.scrollTo();
						});
                }
                if(tooglePlayer){
                    tooglePlayer.addEventListener('click',function (e) {
                        e.preventDefault();
                        e.stopPropagation();
                        $(this).closest('#footer-player').toggleClass('collapsed');
                        if ($(this).closest('#footer-player').hasClass( "collapsed" )) {
                            Themify.body.addClass('footer-collapsed');	
                        }
                        else {
                             Themify.body.removeClass('footer-collapsed');	
                        }		
                    });
                }
                
        },
        like(args){
            Themify.body.on('click', '.likeit', function(e) {
                e.preventDefault();
                e.stopPropagation();
                const $self = $(this);
                $.post(
                        themify_vars.ajax_url,
                        {
                            action: 'themify_likeit',
                            nonce : args.ajax_nonce,
                            post_id: $self.data('postid')
                        },
                        function(response) {
                                const data = $.parseJSON(response);
                                if( 'new' == data.status ) {
                                        $('.count', $self).fadeOut('slow', function(){
                                                $(this).text(data.likers).fadeIn('slow');
                                        });
                                        $(this).addClass('likeit_done');
                                }
                        }
                );
            });  
        },
        onceLoad(args){
                if(this.isDone===null){
                    this.isDone=true;
                    if(document.getElementById('footer-player')){
                        Themify.LoadCss(ThemifyTheme.css_url+'footer-player.css',this.v);
                    }
                    const self = this;
                    setTimeout(function(){
                        self.clickEvents();
                    },1500);
                    if(args.is_ajax){
                        Themify.LoadAsync(this.url + '/js/modules/themify.ajax.js',null, this.v);
                    }
                }
        }
    };
    Themify.on('themify_theme_init',function(){
        ThemifyTheme.init(themifyScript);
    }).trigger('themify_theme_init');
    
})(jQuery,Themify,window,document,themify_vars);
